// Generated by CoffeeScript 1.10.0
(function() {
  var calculator, quad, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  calculator = require('./common/calculator');

  quad = require('./common/quad');

  module.exports = function(pattern, housing) {
    var bodyLength, bodyWidth, fontSize, i, j, k, leadCount1, leadCount2, leadLength1, leadLength2, lineWidth, padDistance1, padDistance2, padHeight1, padHeight2, padParams, padSpace1, padSpace2, padWidth1, padWidth2, pitch, r, rectHeight, rectWidth, ref, ref1, settings, shift, x, y;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["QFP%dP%dX%dX%d-%d"].concat(slice.call([housing.pitch * 100, housing.leadSpan1.nom * 100, housing.leadSpan2.nom * 100, housing.height * 100, housing.leadCount].map((function(_this) {
        return function(a) {
          return Math.round(a);
        };
      })(this)))));
    }
    settings = pattern.settings;
    padParams = calculator.qfp(pattern, housing);
    padParams.pitch = housing.pitch;
    padParams.count1 = housing.leadCount1;
    padParams.count2 = housing.leadCount2;
    pattern.setLayer('top');
    quad(pattern, padParams);
    padWidth1 = padParams.width1;
    padHeight1 = padParams.height1;
    padDistance1 = padParams.distance1;
    padWidth2 = padParams.width2;
    padHeight2 = padParams.height2;
    padDistance2 = padParams.distance2;
    pitch = housing.pitch;
    leadCount1 = housing.leadCount1;
    leadCount2 = housing.leadCount2;
    pattern.setLayer('topSilkscreen');
    lineWidth = settings.lineWidth.silkscreen;
    pattern.setLineWidth(lineWidth);
    rectWidth = housing.bodyWidth.nom;
    padSpace1 = padDistance1 - padWidth1 - 2 * settings.clearance.padToSilk - lineWidth;
    if (rectWidth >= padSpace1) {
      rectWidth = padSpace1;
    }
    rectHeight = housing.bodyLength.nom;
    padSpace2 = padDistance2 - padWidth2 - 2 * settings.clearance.padToSilk - lineWidth;
    if (rectHeight >= padSpace2) {
      rectHeight = padSpace2;
    }
    pattern.addRectangle({
      x: -rectWidth / 2,
      y: -rectHeight / 2,
      width: rectWidth,
      height: rectHeight
    });
    r = 0.25;
    x = (-padDistance1 - padWidth1) / 2 + r;
    y = -pitch * (leadCount1 / 2 - 0.5) - padHeight1 / 2 - r - settings.clearance.padToSilk;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    r = 0.5;
    shift = rectWidth / 2 - r;
    if (shift > 0.5) {
      shift = 0.5;
    }
    x = -rectWidth / 2 + r + shift;
    y = -rectHeight / 2 + r + shift;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r / 2,
      lineWidth: r
    });
    fontSize = settings.fontSize.refDes;
    pattern.addAttribute('refDes', {
      x: 0,
      y: -padDistance2 / 2 - padWidth2 / 2 - fontSize / 2 - 2 * lineWidth,
      halign: 'center',
      valign: 'center'
    });
    pattern.setLayer('topAssembly');
    pattern.setLineWidth(settings.lineWidth.assembly);
    bodyWidth = housing.bodyWidth.nom;
    bodyLength = housing.bodyLength.nom;
    leadLength1 = (housing.leadSpan1.nom - housing.bodyWidth.nom) / 2;
    leadLength2 = (housing.leadSpan2.nom - housing.bodyLength.nom) / 2;
    pattern.addRectangle({
      x: -bodyWidth / 2,
      y: -bodyLength / 2,
      width: bodyWidth,
      height: bodyLength
    });
    y = -pitch * (leadCount1 / 2 - 0.5);
    for (i = j = 1, ref = leadCount1; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      pattern.addLine({
        x1: -bodyWidth / 2,
        y1: y,
        x2: -bodyWidth / 2 - leadLength1,
        y2: y
      });
      pattern.addLine({
        x1: bodyWidth / 2,
        y1: y,
        x2: bodyWidth / 2 + leadLength1,
        y2: y
      });
      y += pitch;
    }
    x = -pitch * (leadCount2 / 2 - 0.5);
    for (i = k = 1, ref1 = leadCount2; 1 <= ref1 ? k <= ref1 : k >= ref1; i = 1 <= ref1 ? ++k : --k) {
      pattern.addLine({
        x1: x,
        y1: -bodyLength / 2,
        x2: x,
        y2: -bodyLength / 2 - leadLength2
      });
      pattern.addLine({
        x1: x,
        y1: bodyLength / 2,
        x2: x,
        y2: bodyLength / 2 + leadLength2
      });
      x += pitch;
    }
    r = 0.5;
    shift = bodyWidth / 2 - r;
    if (shift > 0.5) {
      shift = 0.5;
    }
    x = -bodyWidth / 2 + r + shift;
    y = -bodyLength / 2 + r + shift;
    pattern.addCircle({
      x: x,
      y: y,
      radius: r
    });
    fontSize = settings.fontSize.value;
    return pattern.addAttribute('value', {
      text: pattern.name,
      x: 0,
      y: bodyLength / 2 + leadLength2 + fontSize / 2 + 0.5,
      halign: 'center',
      valign: 'center'
    });
  };

}).call(this);
